#
# need to make atlas required, check module cmd for failure
%define releasebase 6 
%define nbase scalapack
%define prefix /opt/%{nbase}/%{version}/%{compilertag}/%{mpitag}/%{blastag}

%define _libdir %{prefix}/lib
%define _bindir %{prefix}/bin
%define modulepath /opt/Modules/modulefiles/
%define devtoolsetpath /opt/rh/devtoolset-2

#Set  as deafults if no command line inputs
%define as_limulus 1
%define use_gnu4 1
# allow --with[out] <feature> at rpm command line build
%{?_with_gnu4: %{expand: %%define use_gnu4 1}}
%{?_with_pgi: %{expand: %%define use_pgi 1}}
%{?_with_intel: %{expand: %%define use_intel 1}}
%{?_with_pathsc: %{expand: %%define use_pathsc 1}}
# possible MPI's
%{?_with_mpich2: %{expand: %%define use_mpich2 1}}
%{?_with_mpich2omx: %{expand: %%define use_mpich2omx 1}}
%{?_with_ompi: %{expand: %%define use_ompi 1}}
# possible build tags
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
# possible build tags
%{?_with_atlas: %{expand: %%define as_atlas 1}}
%{?_with_openblas: %{expand: %%define as_openblas 1}}
#pick the target
%if "1" == "%{as_basement}"
%define targetbase Basement
%else
%define targetbase Limulus
%endif
# pick the compiler
%if "1" == "%{use_gnu4}"
%define compilertag gnu4
%define compileropts -O2
%endif
%if "1" == "%{use_pgi}"
%define compilertag pgi
%endif
%if "1" == "%{use_intel}"
%define compilertag intel
%endif
%if "1" == "%{use_pathsc}"
%define compilertag pathsc
%endif
%if "1" == "%{use_gnu3}"
%define compilertag gnu3
%define compileropts -O2
%endif
# select MPI
%if "1" == "%{use_ompi}"
%define mpitag openmpi
%define mpiversion 1.8.4
%endif
%if "1" == "%{use_mpich2omx}"
%define mpitag mpich-omx
%define mpiversion 3.1.3
%endif
%if "1" == "%{use_mpich2}"
%define mpitag mpich
%define mpiversion 3.1.3
%endif
%define atlastag gnu4
# select BLAS libarary
# Set the cpuname to the cpu for which the
# libaray was compiled. (gcc-4.4 does not support haswell)

%if "1" == "%{as_openblas}"
%define blasconfline  -L\$(OPENBLAS_PATH) -lopenblas
%define blastag openblas
%define blasver 0.2.13
%define cpuname haswell
%else
%define blasconfline  -L\$(ATLAS_PATH) -llapack -lcblas  -lf77blas -latlas 
%define blastag atlas
%define blasver 3.11.31
%define cpuname ivybridge
%endif

BuildRequires: gcc-gfortran
BuildRequires: lapack-%{compilertag}, blas-%{compilertag}, modules

Group: %{targetbase}/Libraries
Release: %{releasebase}.%{targetbase}

%global _blas_load  module load %{blastag}/%{blasver}/%{compilertag}/%{cpuname};
%global _blas_unload  module unload %{blastag}/%{blasver}/%{compilertag}/%{cpuname};

%global _mpi_load module load %{mpitag}/%{mpiversion}/%{compilertag};
%global _mpi_unload  module unload %{mpitag}/%{mpiversion}/%{compilertag};


Summary: A subset of LAPACK routines redesigned for heterogenous computing
Name: %{nbase}-%{mpitag}-%{blastag}-%{compilertag}
Version: 2.0.2
# This is freely distributable without any restrictions.
License: Public Domain
URL: http://www.netlib.org/lapack-dev/
Source0: scalapack-%{version}.tgz
BuildRequires: lapack-%{compilertag}, blas-%{compilertag}, %{mpitag}-%{compilertag}
BuildRequires: gcc-gfortran, glibc-devel 
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
# Build shared-library for ScaLAPACK (Thanks Fedora)
Patch0: scalapack-2.0.2-fedora.patch
# Add missing functions (Thanks Fedora)  
Patch1: scalapack-2.0.2-missing-functions.patch

%description
The ScaLAPACK (or Scalable LAPACK) library includes a subset 
of LAPACK routines redesigned for distributed memory MIMD 
parallel computers. It is currently written in a 
Single-Program-Multiple-Data style using explicit message 
passing for interprocessor communication. It assumes 
matrices are laid out in a two-dimensional block cyclic 
decomposition.

ScaLAPACK is designed for heterogeneous computing and is 
portable on any computer that supports MPI or PVM.

Like LAPACK, the ScaLAPACK routines are based on 
block-partitioned algorithms in order to minimize the frequency 
of data movement between different levels of the memory hierarchy. 
(For such machines, the memory hierarchy includes the off-processor 
memory of other processors, in addition to the hierarchy of registers, 
cache, and local memory on each processor.) The fundamental building 
blocks of the ScaLAPACK library are distributed memory versions (PBLAS) 
of the Level 1, 2 and 3 BLAS, and a set of Basic Linear Algebra 
Communication Subprograms (BLACS) for communication tasks that arise 
frequently in parallel linear algebra computations. In the ScaLAPACK 
routines, all interprocessor communication occurs within the PBLAS and the 
BLACS. One of the design goals of ScaLAPACK was to have the ScaLAPACK 
routines resemble their LAPACK equivalents as much as possible. 

#
%prep
%setup -q -c -n %{nbase}-%{version}
%patch0 -p1
%patch1 -p1
cd %{nbase}-%{version}/
cd ..
  cp -a %{nbase}-%{version} %{name}-%{version}
  sed -i "s|%{nbase}-%{version}/%{nbase}-%{version}-FOO|%{nbase}-%{version}/%{name}-%{version}|g" %{name}-%{version}/SLmake.inc
  sed -i 's!CBLACSLIB     =!CBLACSLIB     = -L\$(BLACSdir) !g' %{name}-%{version}/SLmake.inc
  sed -i 's!FBLACSLIB     =!FBLACSLIB     = -L\$(BLACSdir) !g' %{name}-%{version}/SLmake.inc
  sed -i 's!BLASLIB       = -lblas!BLASLIB       = %{blasconfline}  !g' %{name}-%{version}/SLmake.inc 
  sed -i 's!LAPACKLIB     = -llapack!LAPACKLIB       = %{blasconfline}  !g' %{name}-%{version}/SLmake.inc 
# set MPI fortran libarary
%if "1" == "%{use_mpich2omx}"
 sed -i 's!CCLOADFLAGS   =!CCLOADFLAGS   = -lmpichf90 !g' %{name}-%{version}/SLmake.inc
%endif
%if "1" == "%{use_mpich2}"
 sed -i 's!CCLOADFLAGS   =!CCLOADFLAGS   = -lmpichf90 !g' %{name}-%{version}/SLmake.inc
%endif
%if "1" == "%{use_ompi}"
 sed -i 's!CCLOADFLAGS   =!CCLOADFLAGS   = -lmpi_mpifh !g' %{name}-%{version}/SLmake.inc
%endif
#set the compiler options
sed -i 's!NOOPT         = -fPIC!NOOPT         = -fPIC %{compileropts}!g' %{name}-%{version}/SLmake.inc

%build
rpm -qf /opt/Modules/bin/modulecmd >& /dev/null
if [ $? -ne 0 ]; then
  echo "This RPM requries the BSC Modules package to build"
fi
. /etc/profile.d/modules.sh

%define dobuild() cd %{name}-%{version} ; sed -i 's!BLACSdir      =.*!BLACSdir      = $(BLACS_PATH)!' SLmake.inc; make lib;  make exe; cd ..

export MPI_COMPILER_NAME=%{mpitag}-%{compilertag}
#check for errors here
%{_mpi_load}
%{_blas_load}
RPM_OPT_FLAGS=`echo $CFLAGS`
which mpif77
echo "ATLAS_PATH =$ATLAS_PATH"
module list
%dobuild
%{_mpi_unload}
%{_blas_unload}

%install
rm -fr ${RPM_BUILD_ROOT}
mkdir -p %{buildroot}%{_libdir}

pushd %{name}-%{version}
cp -f  *.a  *.so* %{buildroot}%{_libdir}

popd
pushd %{buildroot}%{_libdir}/
ln -fs libscalapack.so.1.0.0 libscalapack.so.1
ln -s libscalapack.so.1.0.0 libscalapack.so
popd

# Copy docs
cd %{name}-%{version}
cp -f README ../

# create /etc/ld.so.conf.d/
echo "Creating /opt/etc/ld.so.conf.d/%{name} file"
mkdir -p %{buildroot}/opt/etc/ld.so.conf.d
cat <<EOF> %{buildroot}/opt/etc/ld.so.conf.d/%{name}-%{version}.conf
%{_libdir}
EOF


#create the module file
mkdir -p %{buildroot}/%{modulepath}/%{nbase}/%{version}/%{compilertag}/%{mpitag}/
cat <<EOF >%{buildroot}/%{modulepath}/%{nbase}/%{version}/%{compilertag}/%{mpitag}/%{blastag}
#%Module1.0#######################################################################
##  %{name} modulefile
##

proc ModulesHelp { } {
        puts stderr "\tThis module loads the appropriate environment for "
        puts stderr "\tusing scalapack version %{version}.\n"
}

prereq %{mpitag}/%{version}/%{compilertag}
module-whatis "scalapack %{version}"
module-log error none

set scalapackroot %{prefix}

if [ module-info mode load ] {
  prepend-path  LD_LIBRARY_PATH \$scalapackroot/lib
  setenv SCALAPACK_PATH \$scalapackroot/lib
}
if [ module-info mode remove ] {
  remove-path LD_LIBRARY_PATH \$scalapackroot/lib
  unsetenv SCALAPACK_PATH
}
EOF
%post
/sbin/ldconfig 2>/dev/null
%postun
/sbin/ldconfig 2>/dev/null

%clean
rm -fr ${RPM_BUILD_ROOT}

%files
#%files common
%defattr(-,root,root,-)
%doc  README
%dir %{_libdir}
%{_libdir}/libscalapack.so.*
%{_libdir}/libscalapack.so
%{_libdir}/libscalapack.a
/opt/%{_sysconfdir}/ld.so.conf.d/%{name}-%{version}.conf
%{modulepath}/%{nbase}/%{version}/%{compilertag}/%{mpitag}/%{blastag}

%changelog
* Wed Jan 28 2015 Douglas Eadline <deadline@basement-supercomputing.com>
- updated to 2.0.2, removed separate BLACS dependency
* Fri Dec 12 2012  Douglas Eadline <deadline@basement-supercomputing.com>
- added /opt/etc/ld.so.conf.d entry
* Tue Sep 25 2012 - Douglas Eadline  <deadline@basement-supercomputing.com>
- added ld.so.conf file, module clean up
* Thu Apr 28 2011 deadline <deadline@basement-supercomputing.com>
- modified for BSC cluster use, now one package for all libs in /opt
- uses BSC modules
* Tue Feb 02 2010 Deji Akingunola <dakingun@gmail.com> - 1.7.5-8.2
- Adjust the Obsoletes conditional to fix the broken dependency issue

* Wed Dec 15 2009 Deji Akingunola <dakingun@gmail.com> - 1.7.5-8.1
- mpich2 and openmpi macros can now be sanely removed
- Buildrequire mpich2-devel-static and rebuild for mpich2-1.2.1

* Wed Dec  9 2009 Tom "spot" Callaway <tcallawa@redhat.com> - 1.7.5-8
- drop lam support (Provides/Obsoletes by mpich2, which is a hack, but something's gotta do it)
- move static libs to static subpackages (resolves bz 545150)

* Thu Aug  6 2009 Tom "spot" Callaway <tcallawa@redhat.com> - 1.7.5-7
- rework package to handle all supported MPI environments in Fedora

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.7.5-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.7.5-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Tue Sep 23 2008 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.5-4
- incorporate Deji Akingunola's changes (bz 462424)
- build against openmpi instead of lam

* Tue Jul  8 2008 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.5-3
- fix compile against new lam paths

* Wed Feb 13 2008 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.5-2
- rebuild for new gcc

* Mon Aug 27 2007 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.5-1.1
- rebuild for BuildID

* Thu Jan 18 2007 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.5-1
- bump to 1.7.5

* Fri Sep 15 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.4-4
- I said "BR" not "R". Stupid packager.

* Fri Sep 15 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.4-3
- fix BR: lam-devel

* Fri Sep 15 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.4-2
- fix 64bit patch

* Fri Sep 15 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.4-1
- bump to 1.7.4

* Wed Mar  8 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-13
- lam moved into _libdir/lam... need to fix patches

* Wed Mar  8 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-12
- set -fPIC as NOOPT

* Sun Feb 26 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-11
- fix 64 bit builds
- enable shared libraries
- split package into base and devel

* Tue Feb 14 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-10
- Incorporate Andrew Gormanly's fixes

* Mon Jan  9 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-9
- fix BR

* Mon Dec 19 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-8
- rebuild for gcc4.1

* Sun May 15 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-7
- 64 bit library fix

* Mon May  9 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-6
- remove hardcoded dist tags

* Sun May  8 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-4
- fix broken patch for fc-3 branch

* Sun Apr 24 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-3
- use dist tag
- fix fc3 BuildRequires

* Tue Apr 19 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-2
- fix buildroot
- add gcc-gfortran to BuildRequires (gcc-g77 for fc3)

* Mon Apr 18 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-1
- initial package creation
